diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/rfc2047.c tin-2.6.5/src/rfc2047.c
--- tin-2.6.4/src/rfc2047.c	2024-12-21 03:02:20.000000000 +0100
+++ tin-2.6.5/src/rfc2047.c	2025-12-13 09:36:00.605576940 +0100
@@ -3,10 +3,10 @@
  *  Module    : rfc2047.c
  *  Author    : Chris Blum <chris@resolution.de>
  *  Created   : 1995-09-01
- *  Updated   : 2024-12-21
+ *  Updated   : 2025-12-09
  *  Notes     : MIME header encoding/decoding stuff
  *
- * Copyright (c) 1995-2025 Chris Blum <chris@resolution.de>
+ * Copyright (c) 1995-2026 Chris Blum <chris@resolution.de>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -93,7 +93,7 @@ enum {
  */
 static FILE *compose_message_rfc822(FILE *articlefp, t_bool *is_8bit);
 static FILE *compose_multipart_mixed(FILE *textfp, FILE *articlefp);
-static int do_b_encode(char *w, char *b, size_t max_ewsize, t_bool isstruct_head);
+static int do_b_encode(const char *w, char *b, size_t max_ewsize, t_bool isstruct_head);
 static int sizeofnextword(char *w);
 static int which_encoding(char *w);
 static t_bool contains_8bit_characters(FILE *fp);
@@ -103,7 +103,7 @@ static t_bool rfc1522_do_encode(char *wh
 static t_bool split_mail(const char *filename, FILE **headerfp, FILE **textfp);
 static unsigned hex2bin(int x);
 static void build_base64_rank_table(void);
-static void do_rfc15211522_encode(FILE *f, constext *mime_encoding, struct t_group *group, t_bool allow_8bit_header, t_bool ismail, t_bool contains_headers);
+static void do_rfc15211522_encode(FILE *f, constext *mime_encoding, const struct t_group *group, t_bool allow_8bit_header, t_bool ismail, t_bool contains_headers);
 static void generate_mime_boundary(char *boundary, FILE *f, FILE *g);
 static void generate_random_mime_boundary(char *boundary, size_t len);
 static void str2b64(const char *from, char *to);
@@ -237,9 +237,10 @@ rfc1522_decode(
 	char *t;
 	static char *buffer = NULL;
 	static int buffer_len = 0;
-	size_t max_len;
-	char charset[1024];
+	char charset[CHARSET_MAX_NAME_LEN + 1];
 	char encoding;
+	char csl = CHARSET_MAX_NAME_LEN;
+	size_t max_len;
 	t_bool adjacentflag = FALSE;
 
 	if (!s) {
@@ -247,15 +248,14 @@ rfc1522_decode(
 		return NULL;
 	}
 
-	charset[0] = '\0';
 	c = my_strdup(s);
-	max_len = strlen(c) + 1;
+	max_len = strlen(c);
 
 	if (!buffer) {
-		buffer_len = (int) max_len;
+		buffer_len = (int) max_len + 1;
 		buffer = my_malloc((size_t) buffer_len);
 	} else if (max_len > (size_t) buffer_len) {
-		buffer_len = (int) max_len;
+		buffer_len = (int) max_len + 1;
 		buffer = my_realloc(buffer, (size_t) buffer_len);
 	}
 
@@ -272,18 +272,13 @@ rfc1522_decode(
 #else
 	if (CURR_GROUP.attribute != NULL) {
 #	ifdef USE_ICU_UCSDET
-	if (CURR_GROUP.attribute->undeclared_cs_guess && !(CURR_GROUP.attribute->undeclared_charset && *CURR_GROUP.attribute->undeclared_charset)) {
-		char *guessed_charset;
-
-		if ((guessed_charset = guess_charset(c, 10)) != NULL) {
-			process_charsets(&c, &max_len, guessed_charset, tinrc.mm_local_charset, FALSE);
-			free(guessed_charset);
-		}
-	} else
+		if (CURR_GROUP.attribute->undeclared_cs_guess && !(CURR_GROUP.attribute->undeclared_charset && *CURR_GROUP.attribute->undeclared_charset))
+			csguess_convert_str(&c, "US-ASCII");
+		else
 #	endif /* USE_ICU_UCSDET */
-		process_charsets(&c, &max_len, (CURR_GROUP.attribute->undeclared_charset && *CURR_GROUP.attribute->undeclared_charset) ? (*CURR_GROUP.attribute->undeclared_charset) : "US-ASCII", tinrc.mm_local_charset, FALSE);
+			csguess_convert_str(&c, (CURR_GROUP.attribute->undeclared_charset && *CURR_GROUP.attribute->undeclared_charset) ? *CURR_GROUP.attribute->undeclared_charset : "US-ASCII");
 	} else
-		process_charsets(&c, &max_len, "US-ASCII", tinrc.mm_local_charset, FALSE);
+		csguess_convert_str(&c, "US-ASCII");
 #endif /* !CHARSET_CONVERSION */
 	sc = c;
 
@@ -317,9 +312,17 @@ rfc1522_decode(
 						;
 					continue;
 				}
-				*e++ = *c++;
+				if (csl > 0) {
+					*e++ = *c++;
+					--csl;
+				} else
+					c++;
 			}
 			*e = '\0';
+/*
+			if (!validate_charset(charset))
+				strcpy(charset, "US-ASCII");
+*/
 			if (*c == '?') {
 				++c;
 				encoding = (char) my_tolower((unsigned char) *c);
@@ -397,9 +400,49 @@ str2b64(
 }
 
 
+int
+b642str(
+	const char *in,
+	char *out)
+{
+	char *t;
+	int bits;
+	unsigned pattern;
+	unsigned char x;
+
+	if (!in || !*in)
+		return 0;
+	if (!out)
+		return -1;
+
+	t = out;
+	pattern = 0;
+	bits = 0;
+	build_base64_rank_table();
+
+	while (*in) {
+		x = base64_rank[(unsigned char) (*in++)];
+		if (x == NOT_RANKED) {
+			*t = '\0';
+			return (int) (t - out);
+		}
+		pattern <<= 6;
+		pattern |= x;
+		bits += 6;
+		if (bits >= 8) {
+			x = (unsigned char) ((pattern >> (bits - 8)) & 0xff);
+			*t++ = (char) x;
+			bits -= 8;
+		}
+	}
+	*t = '\0';
+	return (int) (t - out);
+}
+
+
 static int
 do_b_encode(
-	char *w,
+	const char *w,
 	char *b,
 	size_t max_ewsize,
 	t_bool isstruct_head)
@@ -582,9 +625,9 @@ rfc1522_do_encode(
 	char *t;
 	char buf2[80];				/* buffer for this and that */
 	int encoding;				/* which encoding to use ('B' or 'Q') */
-	size_t ew_taken_len;
 	int word_cnt = 0;
 	int offset;
+	size_t ew_taken_len;
 	size_t bufferlen = 2048;		/* size of buffer */
 	size_t ewsize = 0;			/* size of current encoded-word */
 	t_bool quoting = FALSE;		/* currently inside quote block? */
@@ -596,14 +639,16 @@ rfc1522_do_encode(
 	t_bool colon_seen = FALSE;
 	t_bool long_line = FALSE;
 #endif /* MIME_BREAK_LONG_LINES */
-/*
- * the list of structured header fields where '(' and ')' are
- * treated specially in RFC 1522 encoding
- */
+	/*
+	 * the list of structured header fields where '(' and ')' are
+	 * treated specially in RFC 1522 encoding
+	 * (keep the list in cook.c:cook_article() in sync)
+	 */
 	static const char *struct_header[] = {
-		"Approved: ", "From: ", "Originator: ",
-		"Reply-To: ", "Sender: ", "X-Cancelled-By: ", "X-Comment-To: ",
-		"X-Submissions-To: ", "To: ", "Cc: ", "Bcc: ", "X-Originator: ", NULL };
+		"Approved: ", "From: ", "Originator: ", "Reply-To: ",
+		"Sender: ", "X-Cancelled-By: ", "X-Comment-To: ",
+		"X-Submissions-To: ", "To: ", "Cc: ", "Bcc: ", "X-Originator: ",
+		NULL };
 	const char **strptr = struct_header;
 
 	do {
@@ -844,12 +889,10 @@ rfc1522_do_encode(
 	c = buffer;
 	if (break_long_line && any_quoting_done) {
 		char *new_buffer;
-		size_t new_bufferlen = strlen(buffer) * 2 + 1; /* maximum length if
-every "word" were a space ... */
+		size_t new_bufferlen = strlen(buffer) * 2 + 1; /* maximum length if every "word" were a space ... */
 		int column = 0;				/* current column */
 
-		new_buffer = my_malloc(new_bufferlen);
-		t = new_buffer;
+		t = new_buffer = my_malloc(new_bufferlen);
 		word_cnt = 1;			/*
 						 * note, if the user has typed a continuation
 						 * line, we will consider the initial
@@ -933,7 +976,7 @@ static void
 do_rfc15211522_encode(
 	FILE *f,
 	constext *mime_encoding,
-	struct t_group *group,
+	const struct t_group *group,
 	t_bool allow_8bit_header,
 	t_bool ismail,
 	t_bool contains_headers)
@@ -974,7 +1017,7 @@ do_rfc15211522_encode(
 		 * TODO: - what about 8bit chars in the mentioned headers
 		 *         when !allow_8bit_header?
 		 */
-		if (allow_8bit_header || (!strncasecmp(header, "References: ", 12) || !strncasecmp(header, "Message-ID: ", 12) || !strncasecmp(header, "Date: ", 6) || !strncasecmp(header, "Newsgroups: ", 12) || !strncasecmp(header, "Distribution: ", 14) || !strncasecmp(header, "Followup-To: ", 13) || !strncasecmp(header, "X-Face: ", 8) || !strncasecmp(header, "Cancel-Lock: ", 13) || !strncasecmp(header, "Cancel-Key: ", 12) || !strncasecmp(header, "Path: ", 6)))
+		if (allow_8bit_header || (!strncasecmp(header, "Date: ", 6) || !strncasecmp(header, "Path: ", 6) || !strncasecmp(header, "Xref: ", 6) || !strncasecmp(header, "X-Face: ", 8) || !strncasecmp(header, "Newsgroups: ", 12) || !strncasecmp(header, "References: ", 12) || !strncasecmp(header, "Message-ID: ", 12) || !strncasecmp(header, "Supersedes: ", 12) || !strncasecmp(header, "Cancel-Key: ", 12) || !strncasecmp(header, "Cancel-Lock: ", 13) || !strncasecmp(header, "Followup-To: ", 13) || !strncasecmp(header, "Distribution: ", 14)))
 			fputs(header, g);
 		else {
 #ifdef CHARSET_CONVERSION
@@ -1001,7 +1044,7 @@ do_rfc15211522_encode(
 		}
 		if (!allow_8bit_header) {
 			/* see if there are any 8bit chars in the body... */
-			for (c = buf; *c && !isreturn(*c); c++) {
+			for (c = buf; *c && !isreturn((unsigned char) *c); c++) {
 				if (is_EIGHT_BIT(c)) {
 					mime_headers_needed = TRUE;
 					break;
@@ -1053,6 +1096,11 @@ do_rfc15211522_encode(
 		if (mime_headers_needed) {
 			if (contains_headers)
 				fprintf(f, txt_mime_version, MIME_SUPPORTED_VERSION);
+			/*
+			 * for f=f (copy_body() must be fixed first to handle it)
+			 * add something like
+			 * group->attribute->flowed ? "; format=flowed" : ""
+			 */
 #ifdef CHARSET_CONVERSION
 			fprintf(f, txt_mime_hdr_c_type_text_plain_charset, txt_mime_charsets[mmnwcharset]);
 #else
@@ -1097,7 +1145,7 @@ void
 rfc15211522_encode(
 	const char *filename,
 	constext *mime_encoding,
-	struct t_group *group,
+	const struct t_group *group,
 	t_bool allow_8bit_header,
 	t_bool ismail)
 {
@@ -1234,7 +1282,7 @@ split_mail(
 void
 compose_mail_text_plain(
 	const char *filename,
-	struct t_group *group)
+	const struct t_group *group)
 {
 	rfc15211522_encode(filename, txt_mime_encodings[(group ? group->attribute->mail_mime_encoding : tinrc.mail_mime_encoding)], group, (group ? group->attribute->mail_8bit_header : tinrc.mail_8bit_header), TRUE);
 }
@@ -1253,7 +1301,7 @@ compose_mail_mime_forwarded(
 	const char *filename,
 	FILE *articlefp,
 	t_bool include_text,
-	struct t_group *group)
+	const struct t_group *group)
 {
 	FILE *fp;
 	FILE *headerfp;
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/save.c tin-2.6.5/src/save.c
--- tin-2.6.4/src/save.c	2024-12-22 18:24:02.000000000 +0100
+++ tin-2.6.5/src/save.c	2025-12-06 00:10:27.446592917 +0100
@@ -3,10 +3,10 @@
  *  Module    : save.c
  *  Author    : I. Lea & R. Skrenta
  *  Created   : 1991-04-01
- *  Updated   : 2024-12-22
+ *  Updated   : 2025-12-06
  *  Notes     :
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -82,12 +82,12 @@ enum action {
  */
 static FILE *open_save_filename(const char *path, t_bool mbox);
 static char *build_tree(int depth, int maxlen, int i);
-static char *generate_savepath(t_part *part);
+static char *generate_savepath(const t_part *part);
 static int build_part_list(t_openartinfo *art);
 static int get_tagged(int n);
-static int match_content_type(const t_part *part, char *type);
-static t_bool check_save_mime_type(t_part *part, const char *mime_types);
-static t_bool decode_save_one(t_part *part, FILE *rawfp, t_bool postproc);
+static int match_content_type(const t_part *part, const char *type);
+static t_bool check_save_mime_type(const t_part *part, const char *mime_types);
+static t_bool decode_save_one(const t_part *part, FILE *rawfp, t_bool postproc);
 static t_bool expand_save_filename(char *outpath, size_t outpath_len, const char *path);
 static t_bool tag_part(int n);
 static t_function attachment_left(void);
@@ -105,7 +105,7 @@ static void post_process_sh(void);
 static void process_part(t_part *part, t_openartinfo *art, FILE *outfile, const char *savepath, enum action what);
 static void process_parts(t_part *part, t_openartinfo *art, enum action what);
 static void show_attachment_page(void);
-static void start_viewer(t_part *part, const char *path);
+static void start_viewer(const t_part *part, const char *path);
 static void tag_pattern(void);
 static void untag_all_parts(void);
 static void untag_part(int n);
@@ -148,7 +148,6 @@ check_start_save_any_news(
 	int i, j, k;
 	int art_count, hot_count;
 	int saved_arts = 0;					/* Total # saved arts */
-	struct t_article *art;
 	struct t_group *group;
 	t_bool unread_news = FALSE;
 	time_t epoch;
@@ -241,12 +240,29 @@ check_start_save_any_news(
 			}
 		}
 
-		if (!index_group(group)) {
+		if (!index_group(group, TRUE)) {
+			/*
+			 * can't see how this ever could leak, so why bother?
+			 * (next index_group() or tin_done() will take care
+			 * of the free()s and nothing else should modify arts[])
+			 * and if, why not also clear xref and mailbox.next?
+			 * (use free_art_array() then)
+			 */
+#if 0
+			struct t_article *art;
+
 			for_each_art(j) {
 				art = &arts[j];
 				FreeAndNull(art->refs);
 				FreeAndNull(art->msgid);
+				/* FreeAndNull(art->xref); */
+				/* free_mailbox_list(art->mailbox.next); */
 			}
+			/*
+			 * the obove is more or less free_art_array()
+			 * why not also do hash_reclaim() here?
+			 */
+#endif /* 0 */
 			continue;
 		}
 
@@ -341,8 +357,10 @@ check_start_save_any_news(
 			unread_news = TRUE;
 			if (verbose) {
 				char *tmp_hot_count = my_strdup(tin_ltoa(hot_count, 4));
+
+				/* FIXME: translatable/plural-forms */
 				wait_message(0, _(txt_saved_group), tin_ltoa(art_count, 4), tmp_hot_count,
-					PLURAL(art_count, txt_article), group->name);
+					P_(txt_article_sp[0], txt_article_sp[1], art_count), group->name);
 				free(tmp_hot_count);
 			}
 		}
@@ -368,10 +386,10 @@ check_start_save_any_news(
 			/* NOTREACHED */
 
 		case MAIL_ANY_NEWS:
-		case SAVE_ANY_NEWS:
+		case SAVE_ANY_NEWS: /* FIXME: translatable/plural-forms */
 			snprintf(buf, sizeof(buf), _(txt_saved_summary), (function == MAIL_ANY_NEWS ? _(txt_mailed) : _(txt_saved)),
-					saved_arts, PLURAL(saved_arts, txt_article),
-					group_count, PLURAL(group_count, txt_group));
+					saved_arts, P_(txt_article_sp[0], txt_article_sp[1], saved_arts),
+					group_count, P_(txt_group_sp[0], txt_group_sp[1], group_count));
 			fprintf(fp_log, "%s", buf);
 			if (verbose)
 				wait_message(0, "%s", buf);
@@ -510,7 +528,7 @@ save_and_process_art(
 	t_bool mmdf = (is_mailbox && !strcasecmp(txt_mailbox_formats[tinrc.mailbox_format], "MMDF"));
 
 	if (fseek(artinfo->raw, 0L, SEEK_SET) == -1) {
-		perror_message(txt_error_fseek, artinfo->hdr.subj);
+		perror_message(txt_error_fseek);
 		return FALSE;
 	}
 
@@ -537,7 +555,7 @@ save_and_process_art(
 		if (artinfo->hdr.from)
 			strip_name(artinfo->hdr.from, from);
 		else /* shouldn't show up */
-			snprintf(from, sizeof(from), "%s@%s", PATHMASTER, get_host_name());
+			snprintf(from, sizeof(from), "%s@%s", PATHMASTER, BlankIfNull(get_host_name()));
 
 		(void) time(&epoch);
 		fprintf(fp, "From %s %s\n", from, BlankIfNull(str_trim(ctime(&epoch))));
@@ -659,7 +677,7 @@ generate_filename(
  */
 static char *
 generate_savepath(
-	t_part *part)
+	const t_part *part)
 {
 	char *savepath;
 	const char *name;
@@ -881,7 +899,8 @@ post_process_uud(
 		my_flush();
 	}
 
-	my_printf(_(txt_libuu_saved), count, num_save, errors, PLURAL(errors, txt_error));
+	/* FIXME: translatable/plural-forms */
+	my_printf(_(txt_libuu_saved), count, num_save, errors, P_(txt_error_sp[0], txt_error_sp[1], errors));
 	my_printf(cCRLF);
 	UUCleanUp();
 }
@@ -920,7 +939,7 @@ post_process_uud(
 		if ((fp_in = tin_fopen(save[i].path, "r")) == NULL)
 			continue;
 
-		while (fgets(s, (int) sizeof(s), fp_in) != NULL) {
+		while (fgets(s, sizeof(s), fp_in) != NULL) {
 			switch (state) {
 				case INITIAL:
 					if (STRNCMPEQ("begin ", s, 6)) {
@@ -1138,9 +1157,9 @@ post_process_sh(
 
 		wait_message(0, _(txt_extracting_shar), save[i].path);
 
-		while (fgets(buf, (int) sizeof(buf), fp_in) != NULL) {
+		while (fgets(buf, sizeof(buf), fp_in) != NULL) {
 			/* find #!/bin/sh style patterns */
-			if ((fp_out == NULL) && match_regex_ex(buf, (REGEX_SIZE) strlen(buf), 0, 0, &shar_regex) >= 0)
+			if ((fp_out == NULL) && MATCH_REGEX(shar_regex, buf, strlen(buf)))
 				fp_out = fopen(file_out, "w");
 
 			/* write to temp file */
@@ -1189,7 +1208,7 @@ print_art_separator_line(
  */
 static void
 start_viewer(
-	t_part *part,
+	const t_part *part,
 	const char *path)
 {
 	t_mailcap *foo;
@@ -1234,7 +1253,7 @@ start_viewer(
  */
 static t_bool
 decode_save_one(
-	t_part *part,
+	const t_part *part,
 	FILE *rawfp,
 	t_bool postproc)
 {
@@ -1366,7 +1385,7 @@ enum match {
 static int
 match_content_type(
 	const t_part *part,
-	char *type)
+	const char *type)
 {
 	char *subtype;
 	int typeindex;
@@ -1426,7 +1445,7 @@ match_content_type(
  */
 static t_bool
 check_save_mime_type(
-	t_part *part,
+	const t_part *part,
 	const char *mime_types)
 {
 	char *ptr, *pair;
@@ -1516,7 +1535,7 @@ show_attachment_page(
 	char *attach_line;
 	char *buf;
 	const char *charset;
-	int i, tmp_len, max_depth;
+	int i, tmp_len, max_depth, prev_mark_offset = mark_offset;
 	size_t blen;
 	t_part *part;
 
@@ -1540,7 +1559,7 @@ show_attachment_page(
 	for (i = 0; i < attmenu.max; ++i) {
 		part = get_part(i);
 		charset = get_param(part->params, "charset");
-		attach_line = build_attach_line(part, 0, cCOLS - 2, 0, NULL, charset);
+		attach_line = build_attach_line(part, 0, cCOLS - 2, SECTION_DEFAULT, NULL, charset);
 		snprintf(buf, blen, "  %s", attach_line);
 		FreeIfNeeded(attach_line);
 		tmp_len = strwidth(buf);
@@ -1571,6 +1590,7 @@ show_attachment_page(
 	}
 
 	draw_attachment_arrow();
+	mark_offset = prev_mark_offset;
 }
 
 
@@ -1624,6 +1644,11 @@ attachment_page(
 				show_attachment_page();
 				break;
 
+			case GLOBAL_CONNECTION_INFO:
+				show_connection_page();
+				show_attachment_page();
+				break;
+
 			case GLOBAL_BUGREPORT:
 				bug_report();
 				show_attachment_page();
@@ -1673,7 +1698,8 @@ attachment_page(
 
 			case GLOBAL_TOGGLE_INFO_LAST_LINE:
 				tinrc.info_in_last_line = bool_not(tinrc.info_in_last_line);
-				show_attachment_page();
+				clear_message();
+				draw_attachment_arrow();
 				break;
 
 			case GLOBAL_VERSION:
@@ -1718,7 +1744,7 @@ attachment_page(
 				if (attmenu.max) {
 					tag_pattern();
 					show_attachment_page();
-					info_message(_(txt_attachments_tagged), num_of_tagged_parts);
+					info_message(P_(txt_attachment_tagged_sp[0], txt_attachment_tagged_sp[1], num_of_tagged_parts), num_of_tagged_parts);
 				}
 				break;
 
@@ -1729,7 +1755,7 @@ attachment_page(
 					for (i = attmenu.first; i < attmenu.max; ++i)
 						tag_part(i);
 					show_attachment_page();
-					info_message(_(txt_attachments_tagged), num_of_tagged_parts);
+					info_message(P_(txt_attachment_tagged_sp[0], txt_attachment_tagged_sp[1], num_of_tagged_parts), num_of_tagged_parts);
 				}
 				break;
 
@@ -1851,7 +1877,7 @@ build_attachment_line(
 	if (namelen + len + info_len + 8 <= cCOLS)
 		namelen = cCOLS - 8 - info_len - len;
 
-	attach_line = build_attach_line(part, 0, info_len - 2, 0, NULL, charset);
+	attach_line = build_attach_line(part, 0, info_len - 2, SECTION_DEFAULT, NULL, charset);
 	snprintf(buf, sizeof(buf), "  %s", attach_line);
 	FreeIfNeeded(attach_line);
 
@@ -1891,14 +1917,13 @@ build_tree(
 #endif /* MULTIBYTE_ABLE && !NO_LOCALE */
 	int prefix_ptr, tmpdepth;
 	int depth_level = 0;
+	int odd = (maxlen % 2) ? 0 : 1;
 	t_bool found = FALSE;
 	t_partl *lptr, *lptr2;
 
 	lptr2 = find_part(i);
 	prefix_ptr = depth * 2 - 1;
-	if (prefix_ptr > maxlen - 1 - !(maxlen % 2)) {
-		int odd = ((maxlen % 2) ? 0 : 1);
-
+	if (prefix_ptr > maxlen - 1 - odd) {
 		prefix_ptr -= maxlen - ++depth_level - 2 - odd;
 		while (prefix_ptr > maxlen - 2 - odd) {
 			if (depth_level < maxlen / 5)
@@ -2227,7 +2252,7 @@ process_parts(
 
 	switch (what) {
 		case SAVE_TAGGED:
-			wait_message(2, _(txt_attachments_saved), saved_parts, num_of_tagged_parts);
+			wait_message(2, P_(txt_attachment_saved_sp[0], txt_attachment_saved_sp[1], num_of_tagged_parts), saved_parts, num_of_tagged_parts);
 			break;
 
 		case SAVE:
@@ -2270,7 +2295,7 @@ process_part(
 	 * uuencoded parts must be read from the cooked article,
 	 * otherwise they might be additionally encoded with b64 or qp
 	 */
-	if (part->encoding == ENCODING_UUE)
+	if (part->encoding == ENCODING_UUE || part->encoding == ENCODING_YENC)
 		infile = art->cooked;
 	else
 		infile = art->raw;
@@ -2304,7 +2329,7 @@ process_part(
 		 * page.c:new_uue() sets offset to the 'begin ...' line
 		 * -> skip over the first line in uuencoded parts
 		 */
-		if (part->encoding == ENCODING_UUE && i == 0) {
+		if ((part->encoding == ENCODING_UUE || part->encoding == ENCODING_YENC) && i == 0) {
 			++line_count;
 			continue;
 		}
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/screen.c tin-2.6.5/src/screen.c
--- tin-2.6.4/src/screen.c	2024-12-17 16:20:41.000000000 +0100
+++ tin-2.6.5/src/screen.c	2025-12-09 09:37:17.022649632 +0100
@@ -3,10 +3,10 @@
  *  Module    : screen.c
  *  Author    : I. Lea & R. Skrenta
  *  Created   : 1991-04-01
- *  Updated   : 2024-12-13
+ *  Updated   : 2025-12-09
  *  Notes     :
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -50,7 +50,7 @@
 
 int mark_offset = 0;
 
-static FILE* msglog = NULL;
+static FILE *msglog = NULL;
 
 #ifndef USE_CURSES
 	struct t_screen *screen;
@@ -203,7 +203,12 @@ wait_message(
 #	endif /* HAVE_SELECT_INTP */
 			if (nfds == -1) {
 
-				if (errno != EINTR) {
+#	ifdef EINTR
+				if (errno != EINTR)
+#	else
+				if (errno != 0)
+#	endif /* EINTR */
+				{
 					perror_message("wait_message(select()) failed");
 					free(tin_progname);
 					giveup();
@@ -559,13 +564,12 @@ ring_bell(
 #ifdef USE_CURSES
 	if (!cmd_line)
 		beep();
-	else {
+	else
 #endif /* USE_CURSES */
-	my_fputc('\007', stdout);
-	my_flush();
-#ifdef USE_CURSES
+	{
+		my_fputc('\007', stdout);
+		my_flush();
 	}
-#endif /* USE_CURSES */
 }
 
 
@@ -612,8 +616,8 @@ show_progress(
 	time_t curr_time;
 	static char last_display[LEN];
 	static int last_ratio;
-	static t_artnum last_count;
-	static t_artnum last_total;
+	static t_artnum last_count = T_ARTNUM_CONST(0);
+	static t_artnum last_total = T_ARTNUM_CONST(0);
 	static time_t last_update;
 #if defined(HAVE_CLOCK_GETTIME) || defined(HAVE_GETTIMEOFDAY)
 	static int average;
@@ -624,8 +628,8 @@ show_progress(
 	int time_diff;
 	int secs_left;
 	t_artnum count_diff;
-	static struct t_tintime last_time;
-	static struct t_tintime this_time;
+	static struct t_tintime last_time = {0, 0};
+	static struct t_tintime this_time = {0, 0};
 #endif /* HAVE_CLOCK_GETTIME || HAVE_GETTIMEOFDAY */
 
 	if (batch_mode || count <= 0 || total <= 1)
@@ -666,9 +670,7 @@ show_progress(
 		time_diff = (int) (time_diff + ((this_time.tv_nsec - last_time.tv_nsec) / 1000));
 		count_diff = (count - last_count);
 
-		if (!count_diff) /* avoid div by zero */
-			++count_diff;
-
+		count_diff += (count_diff ? 0 : 1); /* avoid div by zero */
 		/*
 		 * Calculate a running average based on the last 20 samples. For the
 		 * first 19 samples just add all and divide by the number of samples.
@@ -770,21 +772,11 @@ open_msglog(
 	void)
 {
 	char logfile[PATH_LEN];
-	char serverdir[PATH_LEN];
 
 	if (msglog != NULL)
 		return;
 
-#ifdef NNTP_ABLE
-	if (read_news_via_nntp && !read_saved_news && nntp_tcp_port != IPPORT_NNTP)
-		snprintf(logfile, sizeof(logfile), "%s:%u", nntp_server, nntp_tcp_port);
-	else
-#endif /* NNTP_ABLE */
-	{
-		snprintf(logfile, sizeof(logfile), "%s", nntp_server);
-	}
-	joinpath(serverdir, sizeof(serverdir), rcdir, logfile);
-	joinpath(logfile, sizeof(logfile), serverdir, "msglog");
+	joinpath(logfile, sizeof(logfile), serverdir, MSGLOG_FILE);
 
 	if ((msglog = fopen(logfile, "w")) != NULL) {
 #ifdef HAVE_FCHMOD
@@ -808,7 +800,7 @@ close_msglog(
 }
 
 
-void
+static void
 log_formatted_msg(
 	const char *tag,
 	const char *msg)
diff -Nurp '--exclude=.bzr*' tin-2.6.4/src/search.c tin-2.6.5/src/search.c
--- tin-2.6.4/src/search.c	2024-12-04 18:08:40.000000000 +0100
+++ tin-2.6.5/src/search.c	2025-12-07 07:11:37.436668075 +0100
@@ -3,10 +3,10 @@
  *  Module    : search.c
  *  Author    : I. Lea & R. Skrenta
  *  Created   : 1991-04-01
- *  Updated   : 2024-12-04
+ *  Updated   : 2025-12-07
  *  Notes     :
  *
- * Copyright (c) 1991-2025 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
+ * Copyright (c) 1991-2026 Iain Lea <iain@bricbrac.de>, Rich Skrenta <skrenta@pbm.com>
  * All rights reserved.
  *
  * Redistribution and use in source and binary forms, with or without
@@ -103,8 +103,8 @@ get_search_pattern(
 	int which_hist)
 {
 	static char tmpbuf[LEN];	/* Hold the last pattern used */
-	static char last_pattern[LEN];	/* last search pattern used; for repeated search */
-	static t_bool last_forward;
+	static char last_pattern[LEN] = { '\0' };	/* last search pattern used; for repeated search */
+	static t_bool last_forward = FALSE;
 
 	if (repeat) {
 		*forward = last_forward;
@@ -183,7 +183,7 @@ search_config(
 	do {
 		if (forward) {
 			if (n == last)
-				n = 0;
+				n = (enum option_enum) 0;
 			else
 				++n;
 		} else {
@@ -272,7 +272,7 @@ generic_search(
 
 			case POSTED_LEVEL:
 				phptr = find_post_hist(n);
-				snprintf(buf, sizeof(buf), "%s %s %s", phptr->date, phptr->group, phptr->subj);
+				snprintf(buf, sizeof(buf), "%s %s %s", phptr->date, BlankIfNull(phptr->group), BlankIfNull(phptr->subj));
 				break;
 
 			case URL_LEVEL:
@@ -396,6 +396,12 @@ body_search(
 
 	/*
 	 * Skip the header - is this right ?
+	 * then we currently don't have a way to search in the headers
+	 * (except author/subject search). if we add some kind of full
+	 * article search we need to decide if it should act on the raw
+	 * headers or even article (so one could search for
+	 * "\b\?iso-8859-\d\d?\?" or the like or on the decoded headers
+	 * (you don't search for base64 raw-data, do you?)
 	 */
 	for (i = 0; artinfo.cookl[i].flags & C_HEADER; ++i)
 		;
@@ -418,7 +424,7 @@ body_search(
 			line = my_strdup(tmp);
 
 		if (tinrc.wildcard) {
-			if (match_regex_ex(line, (REGEX_SIZE) strlen(line), 0, 0, &search_regex) >= 0) {
+			if (MATCH_REGEX(search_regex, line, strlen(line))) {
 				copy_offsets(srch_offsets, srch_offsets_size, &search_regex);
 				srch_lineno = i;
 				art_close(&pgart);		/* Switch the pager over to matched art */
@@ -639,7 +645,7 @@ search_article(
 	t_bool repeat,
 	int start_line,
 	int lines,
-	t_lineinfo *line,
+	const t_lineinfo *line,
 	int reveal_ctrl_l_lines,
 	FILE *fp)
 {
@@ -765,13 +771,14 @@ search_body(
 	t_bool forward_fake = TRUE;
 
 	if (!(buf = get_search_pattern(
-			&forward_fake,				/* we pass a dummy var since body search has no `forward' */
-			repeat,
-			_(txt_search_body),
-			_(txt_search_body),
-			&tinrc.default_search_art,
-			HIST_ART_SEARCH
-	))) return -1;
+		&forward_fake,				/* we pass a dummy var since body search has no `forward' */
+		repeat,
+		_(txt_search_body),
+		_(txt_search_body),
+		&tinrc.default_search_art,
+		HIST_ART_SEARCH
+	)))
+		return -1;
 
 	last_search = GLOBAL_SEARCH_BODY;	/* store last search type for repeated search */
 	total_cnt = curr_cnt = 0;			/* Reset global counter of articles done */
